.character,
.npc,
.lootable {
    select {
        width: 100%;
        padding-top: 1px;
        padding-bottom: 1px;
        margin-left: 2px;
        margin-right: 2px;
    }

    .rollable {
        &:hover,
        &:focus {
            cursor: pointer !important;
            text-shadow: 0 0 8px red;
        }
        * {
            cursor: pointer;
        }
    }

    .sheet-header {
        h1.character-name {
            width: 100%;
            height: 100%;
            input {
                width: 95%;
                height: 100%;
            }
        }
    }

    .tab.main,
    .tab.attributes {
        .ability-grid-container,
        .character-main-block {
            padding: 8px;
        }

        .character-main-block {
            padding: 0px;
            margin: 0px;
        }
        text-align: left;

        .ability-save-grid {
            display: grid;

            grid-template-rows: 1fr;
            grid-template-columns: 1fr 21%;

            gap: 0px;
            height: 100%;
        }
        .ability-tables {
            grid-row-start: 1;
            grid-column-start: 1;

            grid-row-end: 2;
            grid-column-end: 2;
            margin: 1px;
            padding: 1px;
        }
        .save-stats {
            grid-row-start: 1;
            grid-column-start: 2;

            grid-row-end: 2;
            grid-column-end: 3;
            margin: 1px;
            padding: 1px;

            .save-quadrant {
                // border: 1px solid black;
            }
            .save-label {
                // background-color: $c-mid;
                text-align: center;
                font-weight: 700;
                flex-grow: 0;

                grid-row-start: 1;
                grid-column-start: 1;

                grid-row-end: 2;
                grid-column-end: 2;
                margin: 1px;
                padding: 1px;
            }
            .save-value {
                font-weight: normal;
                text-align: center;
                border: 2px solid black;
                border-radius: 12px !important;
                padding: 2px;

                grid-row-start: 1;
                grid-column-start: 2;

                grid-row-end: 2;
                grid-column-end: 3;
                margin: 1px;
                padding: 1px;
            }
        }
        .save-box {
            display: grid;
            grid-template-rows: 1fr;
            grid-template-columns: 1fr 1fr;
            gap: 0px;
            // height: 100%;
            .saves-recalculate {
                text-align: right;
            }
        }

        .flexcol {
            padding: 1px;
        }
        .flexrow {
            padding: 1px;
        }
        .resource {
            flex-grow: 2;
            border-bottom: 1px solid;
        }
        .resource-input {
            height: 18px;
            border: none;
            border-bottom: 1px solid;
        }
        label.ability-score {
            font-size: 1.01em;
        }
        label {
            font-size: 0.99em;
            font-weight: 600;
        }
        select {
            height: 100%;
        }

        .ability-tables {
            text-align: center;

            .ability-label {
                text-transform: uppercase;
            }

            .ability-score {
                input {
                    align-items: center;
                    font-size: 1.4em;
                    width: 38px;
                    padding: 0px;
                    background-color: #fafafa;
                }
            }
            table {
                padding: 0px;
                margin: 0px;
            }
            tr {
                border-top: none;
            }
            .fields {
                tr:nth-of-type(odd) {
                    background-color: $item-background-color;
                }

                tr:nth-of-type(even) {
                    background-color: $item-background-alt-color;
                }

                padding: 4px;
                font-size: smaller;
            }
            th {
                padding: 0px;
                margin: 0px;
                .percent {
                    width: 10%;
                }
            }
            td {
                border: 1px groove black;
                border-bottom: none;
                padding: 0px;
                margin: 0px;
                input.percent {
                    border: none;
                    border-bottom: 1px solid;
                    font-weight: 200;
                    width: 40px;
                    padding: 1px;
                }
                .percent {
                    width: 10%;
                }
            }
        }
    }

    .weapon-block {
        .noAmmoLeft {
            opacity: 0.5;
        }
    }

    .combat-stats {
        font-size: smaller;
        padding: 8px;
        overflow: hidden;

        .combat-stats-breakdown .flexrow > div {
            display: flex;
            justify-content: center;
            align-items: center;
        }
        .combat-stats-breakdown > div > div {
            padding: 5px;
        }

        .underline {
            border-bottom: 1px solid black;
        }

        .combat-box {
            height: 100%;
            justify-content: flex-start;
            align-items: center;
        }

        .armor-icon,
        .hp-icon,
        .movement-icon,
        .thaco-icon,
        .sword-icon,
        .attacks-icon {
            margin-right: 3px;
            background-position: center;
            background-repeat: no-repeat;
            // height:100%;
            // background-size: 70px 55px;
            background-size: 100%;
        }
        .armor-icon {
            background-image: url('icons/general/shield.webp');
            // background-image: linear-gradient(to bottom, rgba(255, 255, 255, 0.5), rgba(255, 255, 255, 0.5)), url("icons/general/shield.webp");
            background-size: 90%;
        }
        .hp-icon {
            background-image: url('icons/general/heart2.webp');
            background-size: 100%;
        }
        .movement-icon {
            // background-size: 36px 47px;
            background-image: url('icons/general/leather-boot.webp');
        }
        .thaco-icon {
            background-image: url('icons/general/combat.webp');
        }
        .sword-icon {
            background-image: url('icons/general/attacks.webp');
        }

        .attacks-per-round-stats {
            justify-content: center;
        }

        .apr-header {
            align-items: center;
            justify-content: center;
            font-weight: 800;
        }

        .apr-tracking-controls {
            margin-top: 5px;
            font-weight: 600;
        }

        .apr-tracking-controls:hover {
            transform: scale(1.5);
            transition: transform 0.25;
        }

        .apr-remaining-label {
            margin-top: 10px;
        }

        .hp-value,
        .psp-value,
        .psi-discipline,
        .psi-closed,
        .ac-value,
        .movement-value,
        .thaco-value,
        .apr-value {
            align-self: center;
            font-size: 2.5em;
            font-weight: 600;
        }
        .variant,
        .hp-value,
        .ac-value,
        .movement-value,
        .thaco-value,
        .apr-value {
            flex-basis: 20px;
            flex-grow: 0;
        }
        label {
            text-align: center;
            margin: 4px;
            height: 50px;
            flex-basis: 50px;
            flex-grow: 0;
            font-weight: normal;
        }
        .combat-value {
            text-align: center;
            border-bottom: 1px solid black;
            border-right: 1px solid black;
            font-weight: normal;
        }
        .combat-label {
            padding: 4px;
            border-right: 1px solid black;
            font-size: 0.98em;
            font-weight: 600;
        }

        .armor-damage {
            margin-top: 3px;
            padding: 3px;
        }

        .armor-damage,
        .health-bar {
            padding-right: 5px;
        }
    }
    .actions-block-list {
        .actionGroup.action-list.noCharges {
            opacity: 0.5;
        }
    }
    .combat-bar {
        margin-left: auto;
        font-size: 0.99em;

        .combat-value {
            text-align: center;
            border-bottom: 1px solid black;
            border-right: 1px solid black;
        }

        .combat-label {
            font-weight: 700;
        }

        .bar {
            margin: 2px;
            flex-basis: 20px;
            flex-grow: 0;
        }
        .bar-right {
            margin: 2px;
            margin-left: auto;
            flex-basis: 20px;
            flex-grow: 0;
        }
        .initiative-block {
            margin-left: 5px;
            flex-basis: 30px;
            flex-grow: 0;

            .roll-initiative {
                flex-basis: 30px;
                flex-grow: 0;
                font-size: 1.09em;
                &:hover,
                &:focus {
                    text-shadow: 0 0 8px red;
                    cursor: pointer;
                }
            }
        }
    }

    .matrix-block {
        text-align: center;
        font-size: smaller;
        .matrix-label {
            font-weight: 700;
            // padding-left: 2px;
            .ac-label {
                border-bottom: 1px solid black;
                border-top: 1px solid black;
                border-right: 1px solid black;
            }
            .roll-label {
                border-bottom: 1px solid black;
                border-right: 1px solid black;
            }
        }
        .ac,
        .hit {
            padding: 1px;
        }
        .ac {
            border-top: 1px solid black;
            border-left: 1px solid black;
            border-right: 1px solid black;
        }
        .hit {
            border: 1px solid black;
        }
    }

    .matrix-block > .flexcol {
        background: $item-background-color;
    }

    // nice little interactive matrix
    .matrix-block.flexrow .flexcol:hover {
        background: rgb(56, 54, 54);
        color: white;
        scale: 1.3;
    }

    .special-attacks-defenses {
        padding: 5px;
    }

    .tab.items {
        font-size: smaller;

        .currency {
            .coin-value {
                input.coins {
                    border: none;
                    border-bottom: 1px solid black;
                }
            }
        }
    }

    .tab.proficiencies {
        font-size: smaller;
    }

    .tab.details {
        font-size: smaller;
        text-align: center;
        .effect-list-types {
            border-bottom: 1px groove black;
        }
        .class-list {
            .inactive {
                opacity: 0.5;
            }
            li:nth-of-type(odd) {
                background-color: $item-background-color;
            }

            li:nth-of-type(even) {
                background-color: $item-background-alt-color;
            }

            .class-active,
            .class-level {
                flex: 0 0 40px;
                flex-grow: 0;
            }

            .class-control {
                padding-top: 4px;
                padding-bottom: 4px;
                padding-left: 8px;
                padding-right: 8px;
                margin-right: 2px;
                font-weight: bold;
                color: #ffffff;
                border: none;
                border-radius: 30px;
                outline: none;
                transition: all 0.3s ease;
            }
            // give remove level red
            .class-control.class-removelevel {
                background-image: linear-gradient(to right, #8a0404 0%, #9e7575 100%);
            }
            .class-control.class-addlevel {
                background-image: linear-gradient(to right, #1f8a04 0%, #7d9e75 100%);
            }
            //not enough xp but we're still showing level up but grey
            .class-control.not-enough-xp {
                background-image: linear-gradient(to right, #575757 0%, #bebebe 100%);
            }

            .class-addlevel:hover {
                cursor: pointer;
                box-shadow: 0 4px 15px rgba(0, 0, 0, 0.2);
                transform: scale(1.1); /* Slightly increases the size */
                background-image: linear-gradient(to left, #1f8a04 0%, #7d9e75 100%);
            }
            // give remove level red
            .class-removelevel:hover {
                cursor: pointer;
                box-shadow: 0 4px 15px rgba(0, 0, 0, 0.2);
                transform: scale(1.1); /* Slightly increases the size */
            }
            //not enough xp but we're still showing level up but grey
            .class-control.not-enough-xp:hover {
                background-image: linear-gradient(to left, #575757 0%, #bebebe 100%);
            }

            // .class-control:hover a {
            //     transform: scale(1.2); /* Slightly more increase for the icon to ensure visibility */
            // }
        }
    }

    .tab.description {
        // .desc-block  {
        // }
        .desc-label,
        .desc-value {
            margin-left: 5px;
            margin-bottom: 5px;
        }
        .desc-label {
            flex-basis: 50px;
            flex-grow: 0;
            font-weight: 700;
        }
        .desc-value {
            flex-grow: 1;
        }
    }

    .inventory {
        min-height: 24px;
    }

    .item-location-controls {
        // font-size: 24px; /* Initial size of the icon */
        color: #000; /* Initial color of the icon */
        transition: transform 0.3s ease, color 0.3s ease;
    }
    .item-location-controls:hover {
        transform: scale(1.5); /* Grow the icon */
        color: var(--ars_red); /* Change the color of the icon */
    }
}

.item-damage.text-trunc,
.item-numatks.text-trunc,
.item-type.text-trunc {
    text-align: center;
}

.items-list.effects-list {
    text-align: left;
}
.effect-source {
    text-align: left;
}

.item-titles .item,
.item-list .item {
    height: 30px !important;
    line-height: 24px;
    padding: 1px 0;
    border-bottom: 1px solid #bbb;
    border-radius: 6px;
}

.item-list {
    //visuals for ammo
    .ammo-container {
        margin-left: 10px;
        margin-bottom: 5px;
        padding-right: 10px;
        display: flex;
        flex-wrap: wrap;
        overflow: hidden;
        gap: 1px; /* Spacing between squares */
        width: 100%;
    }

    .ammo-label {
        margin-right: 2px;
        max-width: 30px;
        min-width: 30px;
    }
    .ammo-infinite {
        font-size: 1.3em;
    }
    .ammo-square {
        // margin-left: 5px;
        width: 10px; /* Width of each square */
        height: 10px; /* Height of each square */
        background-color: #ddd; /* Color for empty squares */
        border: 1px solid #aaa; /* Border for squares */
    }
    .ammo-icon {
        font-size: 10px; /* Small icon size */
        color: #444; /* Color for available ammo */
    }

    .ammo-icon.far {
        color: #ddd; /* Color for empty ammo slots */
    }

    .ammo-square.filled {
        background-color: #444; /* Color for filled squares */
    }

    // visuals for provisions. The bar starts to change color as quantity gets less than 7
    .daily-provisions-rest {
        padding: 2px;
    }

    .item-provision {
        .item-quantity-bar-container {
            font-size: 0.85em;
            background-color: #b1b1b1; /* Fallback color */
            border-radius: 3px;
            width: 100%;
            overflow: hidden; /* Ensure the gradient doesn't spill out */
        }

        .item-quantity-bar {
            height: 10px;
            border-radius: 3px;
            transition: width 0.3s ease, background 0.3s ease;
            max-width: 100%;
            /* Solid green for high quantity */
            background-color: #4caf50;
            display: flex; /* Make this a flex container too */
            justify-content: center; /* Center content horizontally */
            align-items: center; /* Center content vertically */
            font-weight: bold;
        }

        /* Start gradient when quantity is less than 7 */
        .item-quantity-bar[data-quantity='6'],
        .item-quantity-bar[data-quantity='5'] {
            background: linear-gradient(to right, #f44336, #ffeb3b, #4caf50);
        }
        .item-quantity-bar[data-quantity='4'],
        .item-quantity-bar[data-quantity='3'],
        .item-quantity-bar[data-quantity='2'] {
            background: linear-gradient(to right, #f44336, #ffeb3b);
        }
        .item-quantity-bar[data-quantity='1'],
        .item-quantity-bar[data-quantity='0'] {
            background: #f44336;
        }

        /* Solid red for zero quantity */
        .item-quantity-bar[data-quantity='0'] {
            background-color: #f44336;
        }
    }

    .item-entry.quantityZero {
        opacity: 0.35;
    }
}

.carried-weight.actor-titles.flexrow {
    height: 30px;
    display: flex;
    align-content: center;
    background: #ebebeb;
    border-radius: 6px;
}

.general-header .fas.fa-plus,
.general-header .sync-owned-spells {
    float: right;
    margin-right: 10px;
    margin-top: 1px;
}

.general-header .build-spellbook-from-memorized {
    float: right;
    margin-right: 10px;
    margin-top: 1px;
}

.general-header .memslot-random-populate-control {
    float: right;
    margin-right: 10px;
    margin-top: 1px;
}

/* #region advanced search and filtering */

/* toggle search panel */
.btn_toggle_search {
    padding-left: 10px;
}
.ars_clps_on .btn_toggle_search,
.ars_clps_on .btn_select_all,
.ars_clps_on .btn_expand_all {
    display: none;
}

/* search control generic class */
.adv_search_control {
    float: left !important;
    width: 170px !important;
    background: white !important;
    border-radius: 6px !important;
}

/* advanced search/filtering panel */
.pnl_search_controls {
    overflow: hidden;
    max-height: 30px;
    margin-bottom: 0px;
    transition: height;
    height: 0;
    transition: height 0.2s ease-in-out;
}

.pnl_search_controls.open {
    height: 30px;
}

/*#endregion*/

/* #region generic collapsible system */

.ars_clps {
    padding-left: 5px;
}

.ars_clps:before {
    font-family: 'Font Awesome 6 Pro';
    content: '\f0d7';
    font-weight: 900;
    font-size: 1.1em;
    margin-right: 5px;
}

.ars_clps.ars_clps_on:before {
    content: '\f0da';
}

.ars_clps_container {
    display: block;
}

.ars_clps.ars_clps_on + .ars_clps_container {
    display: none !important;
}

/* #endregion */

/* #region misc */

// add alittle padding to the profeciency details/breakdown
.prof-details > div {
    padding: 5px;
    border-radius: 8px;
    border: 2px groove var(--color-border-light-highlight);
}

.ars_clps_container .general-config .flexrow:nth-child(even) {
    background-color: $item-background-color;
}

/* #endregion */
